#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_SquamaExchangeCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_SquamaExchangeCFG> Fish_SquamaExchangeCFG::msSingleton(nullptr);

int Fish_SquamaExchangeCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_SquamaExchangeCFGData* Fish_SquamaExchangeCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_SquamaExchangeCFGData>& Fish_SquamaExchangeCFG::GetMapData()
{
	return mMapData;
}

void Fish_SquamaExchangeCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_SquamaExchangeCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_SquamaExchangeCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mPrice = element->IntAttribute("Price");
		{
			const char* DiscountGift = element->Attribute("DiscountGift");
			std::vector<std::string> vecDiscountGift;
			boost::split(vecDiscountGift, DiscountGift, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecDiscountGift.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecDiscountGift[i].c_str(), &temp))
				{
					data.mDiscountGift.push_back(temp);
				}
			}
		}
		{
			const char* SalePrice = element->Attribute("SalePrice");
			std::vector<std::string> vecSalePrice;
			boost::split(vecSalePrice, SalePrice, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecSalePrice.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecSalePrice[i].c_str(), &temp))
				{
					data.mSalePrice.push_back(temp);
				}
			}
		}
		data.mFinalPrice = element->IntAttribute("FinalPrice");
		{
			const char* RewardList = element->Attribute("RewardList");
			std::vector<std::string> vecRewardList;
			boost::split(vecRewardList, RewardList, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardList.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardList[i].c_str(), &temp))
				{
					data.mRewardList.push_back(temp);
				}
			}
		}
		{
			const char* RewardCount = element->Attribute("RewardCount");
			std::vector<std::string> vecRewardCount;
			boost::split(vecRewardCount, RewardCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardCount[i].c_str(), &temp))
				{
					data.mRewardCount.push_back(temp);
				}
			}
		}
		{
			const char* Rate = element->Attribute("Rate");
			std::vector<std::string> vecRate;
			boost::split(vecRate, Rate, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRate.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRate[i].c_str(), &temp))
				{
					data.mRate.push_back(temp);
				}
			}
		}
		data.mGoldIcon = element->Attribute("GoldIcon");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_SquamaExchangeCFG::Load()
{
	Load("../Config/Fish_SquamaExchangeCFG.xml");
}

Fish_SquamaExchangeCFG* Fish_SquamaExchangeCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_SquamaExchangeCFG());
	}
	return msSingleton.get();
}
